/*
  ==============================================================================

    This file was auto-generated!

    It contains the basic framework code for a JUCE plugin editor.

  ==============================================================================
*/

#include "PluginProcessor.h"
#include "PluginEditor.h"

//==============================================================================
TestProjectAudioProcessorEditor::TestProjectAudioProcessorEditor (TestProjectAudioProcessor& p)
    : AudioProcessorEditor (&p), processor (p),
    lpAttachment(p.state, "LP", sliderLP),
    hpAttachment(p.state, "HP", sliderHP)
{
    // -------------------------------------------------------------------------
    addAndMakeVisible(sliderLP);
    sliderLP.setSliderStyle(Slider::RotaryVerticalDrag);
    sliderLP.setTextBoxStyle(Slider::TextBoxBelow, false, 100, 24);

    addAndMakeVisible(sliderHP);
    sliderHP.setSliderStyle(Slider::RotaryVerticalDrag);
    sliderHP.setTextBoxStyle(Slider::TextBoxBelow, false, 100, 24);

    addAndMakeVisible(labelLP);
    labelLP.setJustificationType(Justification::centred);
    labelLP.attachToComponent(&sliderLP, false);

    addAndMakeVisible(labelHP);
    labelHP.setJustificationType(Justification::centred);
    labelHP.attachToComponent(&sliderHP, false);
    
    // -------------------------------------------------------------------------
    setSize (400, 300);
}

TestProjectAudioProcessorEditor::~TestProjectAudioProcessorEditor()
{
}

//==============================================================================
void TestProjectAudioProcessorEditor::paint (Graphics& g)
{
    g.fillAll (getLookAndFeel().findColour (ResizableWindow::backgroundColourId));
}

void TestProjectAudioProcessorEditor::resized()
{
    // -------------------------------------------------------------------------
    auto rect = getLocalBounds();
    rect.reduce(50, 50);

    // -------------------------------------------------------------------------
    Grid grid;

    grid.items.add(GridItem(sliderLP));
    grid.items.add(GridItem(sliderHP));

    grid.templateColumns = { Grid::TrackInfo(1_fr), Grid::TrackInfo(1_fr) };
    grid.templateRows = Grid::TrackInfo(1_fr);

    grid.performLayout(rect);
}
