/*
  ==============================================================================

    This file was auto-generated!

    It contains the basic framework code for a JUCE plugin processor.

  ==============================================================================
*/

#pragma once

#include "../JuceLibraryCode/JuceHeader.h"

//==============================================================================
/**
*/
class TestProjectAudioProcessor  : public AudioProcessor, 
    public AudioProcessorValueTreeState::Listener
{
public:
    //==============================================================================
    TestProjectAudioProcessor();
    ~TestProjectAudioProcessor();
    AudioProcessorValueTreeState::ParameterLayout createParameterLayout();

    //==============================================================================
    void prepareToPlay (double sampleRate, int samplesPerBlock) override;
    void reset() override;
    void releaseResources() override;

   #ifndef JucePlugin_PreferredChannelConfigurations
    bool isBusesLayoutSupported (const BusesLayout& layouts) const override;
   #endif

    void processBlock (AudioBuffer<float>&, MidiBuffer&) override;

    //==============================================================================
    AudioProcessorEditor* createEditor() override;
    bool hasEditor() const override;

    //==============================================================================
    const String getName() const override { return JucePlugin_Name; }

    bool acceptsMidi() const override
    {
#if JucePlugin_WantsMidiInput
        return true;
#else
        return false;
#endif
    }

    bool producesMidi() const override
    {
#if JucePlugin_ProducesMidiOutput
        return true;
#else
        return false;
#endif
    }

    bool isMidiEffect() const override
    {
#if JucePlugin_IsMidiEffect
        return true;
#else
        return false;
#endif
    }

    double getTailLengthSeconds() const override { return 0.0; }

    //==============================================================================
    int getNumPrograms() override { return 1; }
    int getCurrentProgram() override { return 0; }
    void setCurrentProgram(int index) override { ignoreUnused(index); }
    const String getProgramName(int index) override { ignoreUnused(index); return {}; }
    void changeProgramName(int index, const String& newName) override { ignoreUnused(index, newName); }

    //==============================================================================
    void getStateInformation (MemoryBlock& destData) override;
    void setStateInformation (const void* data, int sizeInBytes) override;

    //==============================================================================
    AudioProcessorValueTreeState state;

private:
    //==============================================================================
    void parameterChanged(const String& parameterID, float newValue) override
    {
        ignoreUnused(parameterID, newValue);

        mustUpdateProcessing.store(true);
    }

    //==============================================================================
    void updateProcessing();

    //==============================================================================
    std::atomic<bool> isActive;
    std::atomic<bool> mustUpdateProcessing;

    //==============================================================================
    std::unique_ptr<dsp::StateVariableFilter::Filter<float>> mHighpassFilterL;
    std::unique_ptr<dsp::StateVariableFilter::Filter<float>> mHighpassFilterR;

    std::unique_ptr<dsp::StateVariableFilter::Filter<float>> mLowpassFilterL;
    std::unique_ptr<dsp::StateVariableFilter::Filter<float>> mLowpassFilterR;

    //==============================================================================
    JUCE_DECLARE_NON_COPYABLE_WITH_LEAK_DETECTOR (TestProjectAudioProcessor)
};
